<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_RatePrice ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_RatePrice extends AbstractStructArrayBase
{
    /**
     * The RatePrice
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_RatePrice[]
     */
    public $RatePrice;
    /**
     * Constructor method for ArrayOfJPSOAP_RatePrice
     * @uses ArrayOfJPSOAP_RatePrice::setRatePrice()
     * @param \StructType\JPSOAP_RatePrice[] $ratePrice
     */
    public function __construct(array $ratePrice = array())
    {
        $this
            ->setRatePrice($ratePrice);
    }
    /**
     * Get RatePrice value
     * @return \StructType\JPSOAP_RatePrice[]|null
     */
    public function getRatePrice()
    {
        return $this->RatePrice;
    }
    /**
     * This method is responsible for validating the values passed to the setRatePrice method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRatePrice method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRatePriceForArrayConstraintsFromSetRatePrice(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_RatePriceRatePriceItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_RatePriceRatePriceItem instanceof \StructType\JPSOAP_RatePrice) {
                $invalidValues[] = is_object($arrayOfJPSOAP_RatePriceRatePriceItem) ? get_class($arrayOfJPSOAP_RatePriceRatePriceItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_RatePriceRatePriceItem), var_export($arrayOfJPSOAP_RatePriceRatePriceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RatePrice property can only contain items of type \StructType\JPSOAP_RatePrice, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RatePrice value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_RatePrice[] $ratePrice
     * @return \ArrayType\ArrayOfJPSOAP_RatePrice
     */
    public function setRatePrice(array $ratePrice = array())
    {
        // validation for constraint: array
        if ('' !== ($ratePriceArrayErrorMessage = self::validateRatePriceForArrayConstraintsFromSetRatePrice($ratePrice))) {
            throw new \InvalidArgumentException($ratePriceArrayErrorMessage, __LINE__);
        }
        $this->RatePrice = $ratePrice;
        return $this;
    }
    /**
     * Add item to RatePrice value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_RatePrice $item
     * @return \ArrayType\ArrayOfJPSOAP_RatePrice
     */
    public function addToRatePrice(\StructType\JPSOAP_RatePrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_RatePrice) {
            throw new \InvalidArgumentException(sprintf('The RatePrice property can only contain items of type \StructType\JPSOAP_RatePrice, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RatePrice[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_RatePrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_RatePrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_RatePrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_RatePrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_RatePrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RatePrice
     */
    public function getAttributeName()
    {
        return 'RatePrice';
    }
}
